;multithreadtest1.asm
.686
.XMM
.model flat,stdcall
option casemap:none
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib


.const
IDM_START_THREAD equ 1
IDM_STOP_THREAD equ 2
IDM_EXIT equ 3
WM_FINISH equ WM_USER+100h
WM_FINISH2 equ WM_USER+101h
.data
ClassName db "Multithreadtest",0
AppName  db "Multithreadtest",0
MenuName db "FirstMenu",0
SuccessString db "200mil iterations thread1 took ms "
SuccessStringb db "                                  ",0
SuccessString2 db "200mil iterations thread2 took ms "
SuccessString3 db "                                  ",0
Format  db "%d",0

StopString db "The thread is stopped",0
EventStop BOOL FALSE
EventStop2 BOOL FALSE

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
hwnd HANDLE ?
hMenu HANDLE ?
ThreadID DWORD ?
ThreadID2 DWORD ?
ExitCode DWORD ?
hThread DWORD ?
hThread2 DWORD ?
hEventStart HANDLE ?
hEventStart2 HANDLE ?
;ALIGN 128
wom1 dd 128 dup(?) ;writeonlymemory output from thread1
wom2 dd 128 dup(?) ;output from thread2
 
.data
TIMER_ID1_SEC           EQU 1
;REAL8's for precision if you decide to run long tests
performancecnt  REAL8 0.0f
performancecnti dd 0
performanceinc  REAL8 10.0f
;ALIGN 128
spinloop    dd 0
dummys      dd 127 dup(0)
spinloopbak dd 20000
;ALIGN 128
rom     REAL4   0.1f ;readonlymemory:threadinput

.code
pause MACRO
    db 0f3h
    db 090h
    ENDM
;put your testcode in this macro
testcode MACRO
    add eax,eax
    fsincos
    ENDM
start:
      invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,300,200,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	invoke GetMenu,hwnd
	mov  hMenu,eax
	.WHILE TRUE
                invoke GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg==WM_CREATE
          invoke CreateEvent,NULL,FALSE,FALSE,NULL
		mov  hEventStart,eax
		mov  eax,OFFSET ThreadProc
		invoke CreateThread,NULL,NULL,eax,\
                             NULL,IDLE_PRIORITY_CLASS,\
                             ADDR ThreadID
                             invoke CreateEvent,NULL,FALSE,FALSE,NULL
		mov  hEventStart2,eax

		mov  hThread,eax
            mov  eax,OFFSET ThreadProc2
		invoke CreateThread,NULL,NULL,eax,\
                             NULL,REALTIME_PRIORITY_CLASS ,\
                             ADDR ThreadID2
		mov  hThread2,eax

	.ELSEIF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
      .ELSEIF uMsg==WM_TIMER
        finit
        fld performancecnt
        fadd performanceinc
        fst performancecnt
        fistp performancecnti 
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.if lParam==0
			.if ax==IDM_START_THREAD
                          mov eax,spinloopbak
                          mov spinloop,eax
                        INVOKE SetTimer,hWnd,TIMER_ID1_SEC,10,NULL
                        fldz
                        fst performancecnt
                        fistp performancecnti
				invoke SetEvent,hEventStart
                        invoke SetEvent,hEventStart2
				invoke EnableMenuItem,hMenu,IDM_START_THREAD,MF_GRAYED
				invoke EnableMenuItem,hMenu,IDM_STOP_THREAD,MF_ENABLED
			.elseif ax==IDM_STOP_THREAD
				mov  EventStop,TRUE
				invoke EnableMenuItem,hMenu,IDM_START_THREAD,MF_ENABLED
				invoke EnableMenuItem,hMenu,IDM_STOP_THREAD,MF_GRAYED
			.else
				invoke DestroyWindow,hWnd
			.endif
		.endif
	.ELSEIF uMsg==WM_FINISH
            invoke wsprintf,ADDR SuccessStringb,ADDR Format,performancecnti
            

		invoke MessageBox,NULL,ADDR SuccessString,ADDR AppName,MB_OK
      .ELSEIF uMsg==WM_FINISH2
            invoke wsprintf,ADDR SuccessString3,ADDR Format,performancecnti
            

            
		invoke MessageBox,NULL,ADDR SuccessString2,ADDR AppName,MB_OK

	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
;slavethread
ThreadProc PROC USES ecx Param:DWORD
        invoke WaitForSingleObject,hEventStart,INFINITE
        mov ebx,spinloop
        .WHILE ebx!=0
               
        mov  ecx,-10000
        .WHILE ecx!=0
                .if EventStop==FALSE
                        testcode
                        
                        inc  ecx
                .else
                        ;invoke MessageBox,hwnd,ADDR StopString,ADDR AppName,MB_OK
                        ;mov  EventStop,FALSE
                        ;jmp ThreadProc
                .endif
        .ENDW
        pause
        mov ebx,spinloop
        
        .ENDW
        
        invoke PostMessage,hwnd,WM_FINISH,NULL,NULL
        invoke EnableMenuItem,hMenu,IDM_START_THREAD,MF_ENABLED
        invoke EnableMenuItem,hMenu,IDM_STOP_THREAD,MF_GRAYED
        jmp   ThreadProc
        ret
ThreadProc ENDP
;masterthread
ThreadProc2 PROC USES ecx Param:DWORD
        invoke WaitForSingleObject,hEventStart2,INFINITE
        mov ebx,spinloop
        .WHILE ebx!=0

        mov  ecx,-10000
        .WHILE ecx!=0
                .if EventStop2==FALSE
                        testcode
                        
                        inc  ecx
                .else
                       ; invoke MessageBox,hwnd,ADDR StopString,ADDR AppName,MB_OK
                       ; mov  EventStop2,FALSE
                       ; jmp ThreadProc2
                .endif
        .ENDW
        dec spinloop        
        mov ebx,spinloop
        .ENDW
        

        invoke PostMessage,hwnd,WM_FINISH2,NULL,NULL
        invoke EnableMenuItem,hMenu,IDM_START_THREAD,MF_ENABLED
        invoke EnableMenuItem,hMenu,IDM_STOP_THREAD,MF_GRAYED
        jmp   ThreadProc2
        ret
ThreadProc2 ENDP

end start
